/*
This file is part of eegltl (Extremely Easy GL Texture Library).

Copyright (c) 2004, 2005 John Tsiombikas <nuclear@siggraph.org>

This library is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _EEGLTL_H_
#define _EEGLTL_H_

#define EEGLTL_ERROR	0xffffffff

namespace eegltl {

	class PixelBuffer;	// fwd decl.

	unsigned int LoadTexture(const char *fname);

	void SetTextureData(unsigned int tex_id, PixelBuffer *pbuf);
	PixelBuffer *LockTexture(unsigned int tex_id);
	void UnlockTexture(PixelBuffer *pbuf);

	void EnableTexture(unsigned int tex_id);
	void DisableTexture();

	bool ScreenCapture(char *fname, enum image_file_format fmt);

	class PixelBuffer {
	private:
		unsigned int tex;

	public:
		unsigned long *buf;
		int x, y;

		PixelBuffer();
		PixelBuffer(unsigned long *data, int x, int y);
		~PixelBuffer();

		friend PixelBuffer *eegltl::LockTexture(unsigned int tex_id);
		friend void eegltl::UnlockTexture(PixelBuffer *pbuf);
	};
}

#endif	// _EEGLTL_H_